﻿using ConsoleApp.TelnetSamples;
using Samples.Calculate;
using Samples.DI;
using Samples.Event;
using Samples.MessagePrinter;
using Samples.StringLength;
using Samples.Telnet;

namespace ConsoleApp;
class Program
{
    static void Main(string[] args)
    {
		#region Delegate

		// CalculateSample.Sample();
		// MessagePrinterSample.Sample();

		#endregion


		#region Callback

		// StringLengthSample.Sample();

		#endregion


		#region Event

		// EventSample.Sample();

		#endregion


		#region Dependency Injection

		// DISample.Sample();

		#endregion


		#region Telnet

		//TelnetConsole console = new TelnetConsole(new StreamTelnetClient());
		//TelnetConsole console = new TelnetConsole(new SocketTelnetClient());

		//console.Start("200.200.200.123");

		#endregion


		#region Async Telnet

		// AsyncTelnetConsole console = new AsyncTelnetConsole(new AsyncStreamTelnetClient());
		AsyncTelnetConsole console = new AsyncTelnetConsole(new AsyncSocketTelnetClient());

		console.Start("200.200.200.123");

		#endregion

	}
}
